unit uGUI;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, uBitFolge;

type
  TGUI = class(TForm)
    eBitFolge: TEdit; lBitfolge: TLabel; eZahl: TEdit; lZahl: TLabel;
    eZeichen: TEdit; lZeichnen: TLabel;
    procedure eBitFolgeKeyPress(Sender: TObject; var Key: Char);
    procedure eZahlKeyPress(Sender: TObject; var Key: Char);
    procedure eZeichenKeyPress(Sender: TObject; var Key: Char);
    procedure eBitFolgeExit(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure eZahlExit(Sender: TObject);
    procedure eZeichenExit(Sender: TObject);
  private
    BitFolge : TBitFolge;
  public
    { Public-Deklarationen }
  end;

var
  GUI: TGUI;

implementation

{$R *.DFM}

procedure TGUI.FormCreate(Sender: TObject);
begin
  BitFolge := TBitFolge.Create;
  eBitFolgeExit(GUI); eZahlExit(GUI); eZeichenExit(GUI);
end;

procedure TGUI.FormDestroy(Sender: TObject);
begin
  BitFolge.Free;
end;

procedure TGUI.eBitFolgeKeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in ['0','1',#8]) then Key := #7; // #7 beep, #8 Backspace
  if (key <> #8) and (length(eBitFolge.text)=8) and (eBitFolge.SelLength=0)
  then Key := #7;
end;

procedure TGUI.eZahlKeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in ['0'..'9',#8]) then Key := #7;
  if (key <> #8) and (length(eZahl.text) = 3) and (eZahl.SelLength=0)
  then Key := #7;
end;

procedure TGUI.eZeichenKeyPress(Sender: TObject; var Key: Char);
begin
  if (key <> #8) and (length(eZeichen.text) = 1) and (eZeichen.SelLength=0)
  then Key := #7;
end;

procedure TGUI.eBitFolgeExit(Sender: TObject);
begin
  BitFolge.fromString(eBitFolge.text);
  eZahl.text := IntToStr(BitFolge.toByte);
  eZeichen.text := BitFolge.toChar;
end;

procedure TGUI.eZahlExit(Sender: TObject);
begin
  if (Length(eZahl.text)>0) and (StrToInt(eZahl.text)<256)
  then BitFolge.fromByte(StrToInt(eZahl.text))
  else FocusControl(eZahl);
  eBitFolge.text := BitFolge.toString;
  eZeichen.text := BitFolge.toChar;
end;

procedure TGUI.eZeichenExit(Sender: TObject);
begin
  if length(eZeichen.text) > 0
  then BitFolge.fromChar(eZeichen.text[1])
  else FocusControl(eZeichen);
  eBitFolge.text := BitFolge.toString;
  eZahl.text := IntToStr(BitFolge.toByte);
end;

end.
